/* 	-*-ObjC-*- */
/*
 *  GGBump.h
 *
 *  Copyright (c) 2002 by Frdric De Jaeger
 *  
 *  Date: January 2002
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __GGBump_h
#define __GGBump_h

typedef struct __vertexData /* GL_T2F_N3F_V3F */
{
  //  Vect3D	texCoord;
  Vect3D	norm;
  Vect3D	v;
}VertexData;

@protocol GGBump
- (void) dataAt: (double) x
	    and: (double) y
	     in: (VertexData *)pdata
       relative: (double *)orig;
- (void) vertexAt: (double) x
	      and: (double) y
	 inDouble: (double [3])dest;
@end

@interface PerlinBump : NSObject <GGBump> 
{}
+ bump;
- (void) dataAt: (double) x
	    and: (double) y
	     in: (VertexData *)pdata
       relative: (double *)orig;
- (void) vertexAt: (double) x
	      and: (double) y
	 inDouble: (double [3])dest;
@end


@interface PerlinBumpSphere : PerlinBump 
{
  double	radius;
}
+ bumpWithRadius: (double) r;
@end

@interface PerlinBumpSphereTop : PerlinBumpSphere
@end

@interface PerlinBumpSphereBottom : PerlinBumpSphere
@end

@interface PerlinBumpCube : PerlinBump
{
  Vect3D	dirnorm;
  Vect3D	dirx, diry;
}
+ bumpWithNorm: (Vect3D)v
	   dir: (Vect3D)w;
@end

#endif




