/* 	-*-ObjC-*- */
/*
 *  GGGlyphLayout.h
 *
 *  Copyright (c) 2001 by Frdric De Jaeger
 *  
 *  Date: Mars 2001
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __GGGlyphLayout_h
#define __GGGlyphLayout_h

#include <GL/gl.h>
#include <Foundation/NSGeometry.h>

@class GGFont;
@class Texture;

#include "type.h"

typedef enum __alignement
{
  TopAlignement,
  CenterAlignement,
  BottomAlignement
}Alignement;

@interface GGGlyphLayout : NSObject
{
  GGFont 		*layoutFont;
  InterLeavedT2V3	*ilArray;
  int			nChunk;
  NSRect		boundRect;
  NSString		*string;
  BOOL			multiLigne, empty;
  Alignement		alignement;
}
+ glyphLayoutWithString: (NSString *)s;
+ glyphLayoutWithString: (NSString *)s
	       withFont: (GGFont *)f;

- initWithFont: (GGFont *) font
	string: (NSString *) str;
- (void) updateString: (NSString *)str;
- (void) fastDraw;
- (void) drawAtPoint: (NSPoint) aPoint;
- (NSRect) frameRect;
- (void) setAlignement: (Alignement) newAli;
@end


#endif
