/* 	-*-ObjC-*- */
/*
 *  GGInput.h
 *
 *  Copyright (c) 2001 by Frdric De Jaeger
 *  
 *  Date: Mars 2001
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include "GGShip.h"

#ifndef __GGInput_h
#define __GGInput_h


@class GGOrbiteur;
@class Commandant;
@class GGGlyphLayout;
@class Console;
@class TopView;
@class Station;

#include "NSWindow.h"
#include "TopView.h"


@interface GGInput : NSWindow
{
  Commandant			*ship;
  GGTableau        		*tableauDeBord;
  GGSpaceObject			*externCamera;
  int 				trackMode;
  int 				xold, yold, xcur, ycur;
  Console			*theConsole;
  TopView			*currentView;
  NSMutableArray		*stackView;
  GUIState			guiState;
  int				cameraMove;
  float				distanceCamera;
  Station			*station;
}
- (GGShip *) ship;
- (void) setShip: (Commandant *) unShip;
- (Console *)console;
- (void) addTopView: (TopView *) aView;
- (void) aTopViewIsClosing: (TopView *) aView;
- (void) setInStation: (Station*) s;
@end

extern GGInput *theGGInput;

#endif
