/* 	-*-ObjC-*- */
/*
 *  GGWidget.h
 *
 *  Copyright (c) 2001 by Frdric De Jaeger
 *  
 *  Date: Mars 2001
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __GGWidget_h
#define __GGWidget_h

#include <Foundation/NSGeometry.h>
#include "NSView.h"

@class Texture;
@class GGGlyphLayout;
@class GGFont;
@class GGIcon;

typedef enum _NSButtonType {
  NSMomentaryPushButton,
  //  NSPushOnPushOffButton,
  NSToggleButton,
  /*  NSSwitchButton,
  NSRadioButton,
  NSMomentaryChangeButton,
  NSOnOffButton,
  NSMomentaryLight*/
} NSButtonType;


@interface GGBouton : NSView
{
  int			tag;
  id			target;
  SEL			action;
  NSButtonType		type;
  int			state;
  NSString		*str;
  GGGlyphLayout		*strLayout;
  GGIcon		*icon;
  NSPoint		textOrigin;
  NSPoint		iconOrigin;
  BOOL			border;
  BOOL			highlighted;
}
+ button;
- (int) tag;
- (void) setTag: (int)obj;
- (void) setTitle: (NSString *) theStr;
- (void) setTitle: (NSString *) theStr
	 withFont: (GGFont *) f;
- (void) setTarget: obj;
- (void) setBorder: (BOOL) val;
- (void) setAction: (SEL) aSel;
- (void) setType: (NSButtonType) theType;
- (void) setState: (int) state;
- (int) state;
- (void) setButtonType: (NSButtonType)aType;
- (void) setIcon: (GGIcon *) _icon;
@end

@interface GGString : NSView
{
  NSString 		*str;
  GGGlyphLayout		*strLayout;
}
- (void) updateString: (NSString *)Astr;
- (void) setString: (NSString *)aStr;
- (void) setString: (NSString *) aStr
	  withFont: (GGFont *) f;
@end

@interface GGOption : NSView
{
  GGBouton 		*bo;
  GGString		*str;
}
+ optionWithStr: (NSString *) str;
- (void) setType: (NSButtonType) aType;
- (void) setTarget: obj;
- (void) setAction: (SEL) aSel;
- (void) setState: (int) state;
- (void) setTag: (int) obj;
- (void) setButtonType: (NSButtonType)aType;
@end

extern float GGBorderColor[3];
#endif
