/*
 *  Goodies.m
 *
 *  Copyright (c) 2001 by Frdric De Jaeger
 *  
 *  Date: Mars 2001
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#include <GL/gl.h>
#include <stdio.h>
#include <stdlib.h>
#include <unistd.h>
#include <Foundation/NSObject.h>
#include <Foundation/NSDebug.h>
#include <Foundation/NSException.h>
#include <Foundation/NSDictionary.h>
#include <Foundation/NSArray.h>


#include "Metaobj.h"
#include "Tableau.h"
#include "World.h"
#include "NSWindow.h"
#include "GGWidget.h"
#include "GGShip.h"
#include "utile.h"
#include "parseASC.h"
#include "GGMenu.h"
#include "Item.h"
#include "Commandant.h"
#include "Goodies.h"
#include "GGFont.h"
#include "Console.h"
#include "GGScrollView.h"


@implementation MarketPlace
- (void) _updateFric
{
  [fric setString: [NSString stringWithFormat: @"%g $", theCommandant->fric]];
  [masseFret setString: [NSString stringWithFormat: @"%d reste %d",
				  (int)(theCommandant->masseFret/1e3), 
				  (int)((theCommandant->capaciteFret-
					 theCommandant->masseFret)/1e3)]];
}

- initWithGoodies: (NSArray *) goodies
{
  int n;
  NSRect frame;

  [self initWithFrame: NSMakeRect(0,40, VirtualWidth-100, VirtualHeight-100)];
  frame = [self frame];


  n = [goodies count];
  if( n > 0 )
    {
      GGMenu *m;
      GGScrollView *scroll;
      int i;
      Item *items[n];
      [goodies getObjects: items];
      scroll = [[GGScrollView alloc] 
		 initWithFrame: NSMakeRect(50, 50, frame.size.width - 70,
					   frame.size.height-90)];
      [self addSubview: scroll];

      menu = m = [GGMenu menu];
      
      for( i = 0; i < n; ++i)
	{
	  Quantite *q;
	  items[i]->quantite = [theCommandant nbrItem: items[i]];
	  q = [Quantite quantiteWithItem: items[i]];
	  [q setManager: self
	     withSelectorForBuy: @selector(buyFrom:)
	     andSelectorForSell: @selector(sellFrom:)];
	  [m addMenuItem: q]; 
	}
      [m endItem];

      [scroll setDocumentView: m];
      RELEASE(scroll);
    }

  fric = [GGString new];
  [fric setFrameOrigin: NSMakePoint(10, 10)];

  masseFret = [GGString new];
  [masseFret setFrameOrigin: NSMakePoint(10, 25)];

  [self _updateFric];
  
  [self addSubview: fric];
  [self addSubview: masseFret];

  return self;
}

- (void) dealloc
{
  RELEASE(fric);
  RELEASE(masseFret);
  [super dealloc];
}

- (void) viewWillMoveToWindow: (NSWindow*)newWindow
{
  [super viewWillMoveToWindow: newWindow];
  if( newWindow )
    [newWindow makeFirstResponder: menu];
}

- (void) buyFrom: (Quantite *)qte
{
  Item *it;
  ShipErrorCode code;
  it = [qte item];
  if( (code = [theCommandant buyItem: it]) == NoError )
    {
      [qte setQuantite: [theCommandant nbrItem: it]];
      [self _updateFric];
      //      NSWarnMLog(@"fric %g", theCommandant->fric);
    }
  else
    consoleLog(shipMsgFromErrorCode(code));
}

- (void) sellFrom: (Quantite *)qte
{
  Item *it;
  ShipErrorCode code;
  it = [qte item];
  if( (code = [theCommandant sellItem: it]) == NoError )
    {
      [qte setQuantite: [theCommandant nbrItem: it]];
      [self _updateFric];
      //      NSWarnMLog(@"fric %g", theCommandant->fric);
    }
  else
    consoleLog(@"erreur %d", code);
}
@end



@implementation Quantite
- (void) setSellButton
{
  GGBouton *qu_bo;
  temp = qu_bo = AUTORELEASE([GGBouton new]);
  [qu_bo setFrame: NSMakeRect(25, 5, 15, 15)];
  //  [qu_bo setType: NSToggleButton];
  [qu_bo setTarget: self];
  [qu_bo setAction: @selector(send)];
  [self addSubview: qu_bo];
}

- (void) removeSellButton
{
  [temp removeFromSuperview];
  temp = nil;
}

- initWithName: (NSString *)name
	  item: (Item *)i
{
  GGBouton *qu_bo;
  [self initWithFrame: NSMakeRect(0, 0, 700, 30)];

  ASSIGN(theItem, i);

  qu_bo = AUTORELEASE([GGBouton new]);
  [qu_bo setFrame: NSMakeRect(5, 5, 15, 15)];
  //  [qu_bo setType: NSToggleButton];
  [qu_bo setTarget: self];
  [qu_bo setAction: @selector(buy)];
  [self addSubview: qu_bo];

  if( i->quantite > 0 )
    [self setSellButton];
    

  str = [GGString new];
  [str setFrame: NSMakeRect(50, 5, 200, 20)];
  [str setString: name];
  [self addSubview: str];

  prix1 = [GGString new];
  [prix1 setString: @"---"];
  [prix1 setFrame: NSMakeRect(350, 5, 70, 20)];
  [self addSubview: prix1];

  prix2 = [GGString new];
  [prix2 setString: @"---"];
  [prix2 setFrame: NSMakeRect(450, 5, 70, 20)];
  [self addSubview: prix2];

  masse = [GGString new];
  [masse setString: @""];
  [masse setFrame: NSMakeRect(550, 5, 50, 20)];
  [self addSubview: masse];

  return self;
}

- initWithItem: (Item *)it
{
  [self initWithName: it->name
	item: it];
  [self setPrixAchat: it->prixAchat
	prixVente: it->prixVente];
  [self setQuantite: it->quantite];
  NSDebugLLog(@"Quantite", @"%d", it->quantite);
  if( it->masse > 0 )
    [masse setString: [NSString stringWithFormat: @"%d", 
				((int)(it->masse))/1000]];
  return self;
}

- (void) setManager: obj
 withSelectorForBuy: (SEL) aSelBuy
 andSelectorForSell: (SEL) aSelSell
{
  target = obj;
  selBuy = aSelBuy;
  selSell = aSelSell;
}

- (void) setQuantite: (int) val
{
  theItem->quantite = val;
  //  [qte setString: [NSString stringWithFormat: @"%d", val]];
}

- (void) setPrixAchat: (int) prixA
	    prixVente: (int) prixV
{
  [prix1 setString: [NSString stringWithFormat: @"%d", prixA]];
  [prix2 setString: [NSString stringWithFormat: @"%d", prixV]];
}

- (void) buy
{
  [target performSelector: selBuy
	  withObject: self];
  if( theItem->quantite > 0 && temp == nil )//so was 0
    {
      [self setSellButton];
    }
}

- (void) send
{
  [target performSelector: selSell
	  withObject: self];
  if( theItem->quantite == 0 && temp != nil )
    {
      [self removeSellButton];
    }
}

- (Item *) item
{
  return theItem;
}

- (void) dealloc
{
  RELEASE(str);
  RELEASE(prix1);
  RELEASE(prix2);
  RELEASE(theItem);
  RELEASE(masse);
  [super dealloc];
}

+ quantiteWithItem: (Item *) it
{
  return AUTORELEASE([[self alloc] initWithItem: it]);
}

@end
