/* 	-*-ObjC-*- */
/*
 *  Item.h
 *
 *  Copyright (c) 2001 by Frdric De Jaeger
 *  
 *  Date: Mars 2001
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __Item_h
#define __Item_h

typedef enum __itemtype
{
  LaserPulsion,
  LaserRayon,
  Hyperdrive,
  Missile,
  Mine,
  BombeEnergie,
  ECM,
  GoodiesBegining,
  Slaves,
  Animals,
  Hydrogen,
  Computers,
  Foods,
  Gems,
  Narcotics,
  Other
}ItemType;

@interface Item : NSObject
{
  @public
  ItemType		type;
  int			arg1, arg2, arg3;
  float			masse;
  int			prixAchat, prixVente;
  int			quantite;
  NSString		*name;
}
+ (NSArray *) itemList;
+ itemWithType: (ItemType) type;
+ itemWithName: (NSString *) aName
	  type: (int) aType
	   arg: (int) aArg
     prixAchat: (int) aPrixAchat
     prixVente: (int) aPrixVente;
+ itemWithName: (NSString *) aName
	  type: (int) aType
	   arg: (int) aArg
     prixAchat: (int) aPrixAchat
     prixVente: (int) aPrixVente
	 masse: (int) m;
- (void) setItemName: (NSString *)_name;
@end

#endif
