/* 	-*-ObjC-*- */
/*
 *  Missile.h
 *
 *  Copyright (c) 2001 by Frdric De Jaeger
 *  
 *  Date: Mars 2001
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __Missile_h
#define __Missile_h

#include "Task.h"

typedef enum __typeAutoPilote  {
  ModeMissile,
  ModeVaisseau
}TypeAutoPilote;


@class GGTimer;
@class GGSpaceObject;

@interface AutoPilotCommon : GGTask <NSCoding>
{
  GGSpaceObject		*theTarget;  /*Not retained but we should be warned
				       of its destruction*/
  int			modeFlight;
  TypeAutoPilote	type;
  PetitGalileen 	gal;

  double		timeOfLeaving;			
  NSString		*signature;  //retained
  double 		lastTime;

  /*advanced seting:
   */

  /*point we reaylly want to reach.  express as a translation of the
    destination computed in the coordinates of the father of the
    destination */
  Vect3D		decal; 

  /*speed allowed when we reach the target*/
  real			admissibleSpeed;

  /*distance of the target we should reach with the given admissibleSpeed
   */

  real			distanceTarget;
}
+ autoPilotWithTarget: (id) aTarget
	      andShip: (GGShip *) aShip
		decal: (Vect3D *) pdecal
		speed: (real) v
	     distance: (real) _d;
+ autoPilotWithTarget: (id) aTarget
	      andShip: (GGShip *) aShip;
+ missilePilotWithTarget:(id) aTarget
		 andShip: (GGShip *) aShip;

- (PetitGalileen *) positionRelativeCible;
- (double) estimatedDateAtDestination;
@end

extern NSString *GGMissileArrive;

#endif
