/* 	-*-ObjC-*- */

#ifndef __NSWindow_h
#define __NSWindow_h


#include "NSResponder.h"
#include "GGLoop.h"

@class NSString;
@class NSArray;
@class NSMutableArray;
@class NSData;

@class NSWindow;
@class NSView;
@class NSClipView;
@class NSImage;
@class NSCursor;


@interface NSWindow : NSResponder <InputHandler>
{
  NSView 		*contentView, *metaView;;
  NSView 		*firstResponder;
  NSWindow		*windowOnTop, *windowBelow, *windowAbove;
  NSWindow		*firstOpaque;
  NSView		*grabeur, *viewUnderMouse;
  NSRect		frameWindow;
  int 			open;
  VectCol		couleur;
  BOOL			doBackGround;
}
+ window;

- (void) setFrameWindow: (NSRect) aRect;
- initWithFrame: (NSRect) aRect;
- (void) initWindowGL;
- (void) setDrawBackground:(BOOL) f;

- (NSView *)firstResponder;
- (void) makeFirstResponder: (NSView *)aView;

- (void) setOpacity:(float) val;
- (real) opacity;
- (void) setBackgroundColor: (VectCol) val;

- (void) drawWindow;

- (void) setContentView: (NSView *) v;
- (NSView *)contentView;
- (void) setGLFrameInRect: (NSRect) _aRect;
- (void) setFrameInRect: (NSRect) aRect
	       atOrigin: (NSPoint) aPoint;
- (void) display;
- (void) flushWindow;
- (void) setViewsNeedDisplay: (BOOL) flag;
- (BOOL) isOpen;
- (void) open;
- (void) close;
- (void) pushOnTheTop: (NSWindow *)aWin;
- (void) pushWindow: (NSWindow *) aWin;
- (NSWindow *) popWindow;
- (BOOL) isOpaque;
- (void) grabEvent: (NSView *)theGrab;
- (void) unGrabEvent;
- (void) setWindowBelow: (NSWindow *)win;
- (NSWindow *)windowBelow;
- (NSWindow *) windowOnTop;

- (void) takeFocus;
- (void) looseFocus;

- (void) addCloseButton;
@end

//  #define VirtualWidth 640
//  #define VirtualHeight 480
#define HeightTableau 50
#define VirtualWidth WIDTH
#define VirtualHeight (HEIGHT - HeightTableau)


#endif // _GNUstep_H_NSView

