/* 	-*-ObjC-*- */

#ifndef __Sound_h
#define __Sound_h

@class FileSample;
@class NSFileHandle;

@class NSData;
@class NSTask;
@class NSLock;

@protocol Sample
- (NSData *) dataWithSize: (int) val;
@end

@interface Sound : NSObject
{
  int		caps;
  int 		fd;
  int 		format;
  int 		channel;
  int		speed;
  int		fragSize;
  int		sizeBuffer;
  int		toWrite;
  unsigned char *buffer;
  NSObject<Sample>*object;
  NSLock	*lock;
  volatile BOOL	shouldEnd;
  volatile BOOL	running;
}

- (void) runSample;
- (void) playFile: (NSString *)file;
- (void) endSound;
- (BOOL) running;
@end

@interface FileSample  : NSObject <Sample>
{
  NSFileHandle  *file;
}
+ newWithFile: (NSString *)name;
- (NSData *) dataWithSize: (int) val;
- (void) closeAndRelease;
@end
extern Sound *theSound;

@interface Mpeg  : NSObject <Sample>
{
  NSTask	*theTask;
  NSFileHandle	*readHandle;
}
+ newWithFile: (NSString *)name;
- (NSData *) dataWithSize: (int) val;
- (void) closeAndRelease;
@end

#endif
