/* 	-*-ObjC-*- */
/*
 *  System.h
 *
 *  Copyright (c) 2001 by Frdric De Jaeger
 *  
 *  Date: May 2001
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __System_h
#define __System_h

#include <Foundation/NSObject.h>
#include "GGSky.h"
#include "Planete.h"
@class GGOrbiteur;
@class GGTimer;

typedef enum __systeme_type
{
  Modern = 0,
  Farmer = 1,
  Intermediate = 2
}SystemType;

typedef enum __syteme_speciality
{
  Luxury 		= 0x1,
  Drugs 		= 0x2,
  Integrist 		= 0x4
}SystemSpeciality;


@interface System : NSObject
{
  GGOrbiteur		*mainStar;
  SystemType		systemType;
  SystemSpeciality	systemSpeciality;
  float			population;
  System		*theSystem;
  int			index;
  GGTimer		*aTimer;
}
+ systemAt: (Star*) s;
- (GGOrbiteur *) mainStar;
- (NSArray *) shipMaterialToSel;
- (NSArray *) goodiesToSel;
- (NSString *) systemType;
- (int) index;
- (Vect3D) randomVect;
- (void) makeCurrent;
- (void) endCurrent;
- (NSArray *) allStations;
@end

#endif
