/* 	-*-ObjC-*- */
/*
 *  Tableau.h
 *
 *  Copyright (c) 2001 by Frdric De Jaeger
 *  
 *  Date: Mars 2001
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __Tableau_h
#define __Tableau_h

#include "config.h"
#include "NSView.h"

@class NSMutableArray;
@class GGSpaceObject;
@class GGOrbiteur;
@class Commandant;
@class GGFont;
@class Radar;
@class Console;

@interface StringArray : NSObject
{
  GGFont		*theFont;
  NSMutableString	*theString;
}
+ stringArray;
- addString: (NSString *) format,...;
- (void) clear;
- (void) displayAt: (int) x and: (int) y;
@end


@interface GGTableau : NSObject
{
@public
  Commandant		*observeur;
  GGOrbiteur		*closestOrbiteur;
  real			distance, speed;
  StringArray		*string;
  StringArray		*log;
  GGFont		*font;

  NSRect		frameRect;

  short int		xCible, yCible;
  float			distCible;


  short int		xDest, yDest;
  float			distDest;

  short int		xVit, yVit;

  short			xDir, yDir;

  short		       	xVitDest, yVitDest;

  float			joyXPos, joyYPos;
  BOOL			posCibleCorrect;
  BOOL			posDestCorrect;
  BOOL			posVitCorrect;
  BOOL			posDirCorrect;
  BOOL			posVitDestCorrect;
  BOOL			destIsTarget;
}

- (void) setJoyXPos: (float) val;
- (void) setJoyYPos: (float) val;
- (void) setFrameRect: (NSRect) aRect;
- (void) drawTableau;
- (void) setClosestOrbiteur: (GGOrbiteur *)theOrb;
- (GGOrbiteur *) closestOrbiteur;
- (void) setPositionCible: (int) x 
		      and: (int)y 
		     dist: (float) dist;
- (void) setObserveur: (GGSpaceObject *) obj;
- (void) addLogString: (NSString *)s,...;
- (void) doIndicator: (ProjectionParam *)ppp
	      camera: (GGSpaceObject *) camera;

- (GGSpaceObject *) observeur;
@end

extern GGTableau *theTableau;
@class GGTimer;
@class GGGlyphLayout;

@interface ViewTableau : NSView
{
  GGGlyphLayout		*dateString;
  Console 		*theConsole;
  GGTimer		*timer;
}
- (Console *) console;
@end


#ifdef DEBUG
#include <Foundation/NSDebug.h>
#define NSDebugMLLogWindow(level, format, args...) \
  do { if (GSDebugSet(level) == YES) { \
    NSString *fmt = GSDebugMethodMsg( \
	self, _cmd, __FILE__, __LINE__, format); \
    [theTableau addLogString: fmt , ## args]; }} while (0)


#define NSDebugLLogWindow(level, format, args...) \
  do { if (GSDebugSet(level) == YES) \
    [theTableau addLogString: format , ## args]; } while (0)
#else
#define NSDebugMLLogWindow(level, format, args...)
#define NSDebugLLogWindow(level, format, args...)
#endif




#endif
