/* 	-*-ObjC-*- */
/*
 *  Missile.h
 *
 *  Copyright (c) 2001 by Frdric De Jaeger
 *  
 *  Date: Mars 2001
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __Task_h
#define __Task_h

#include <Foundation/NSObject.h>

@class NSMutableArray;
@class GGShip;
@class Station;
@class GGTimer;

@interface GGTask : NSObject <NSCoding>
{
  GGTask		*fatherTask;	// not retained of course.
  NSMutableArray	*subTask;	//retained of course
  GGShip		*ship;		//not retained !!
  GGTimer		*endTaskTimer;  //retained
}
- (void) setShip: (GGShip  *) aShip;  //don't retain it's arg
- initWithShip: (GGShip *)_ship;
- (void)addSubTask: (GGTask *) aTask;
- (void) removeSubTask: (GGTask *)aTask;
- (void) doinvalidate;
- (void) invalidate;


@end

@interface FlightToStation : GGTask
{
  NSString		*stationName;	//retained!!
  int			mode;
}
- (void) startRunning;
+ destination: (Station *)_station
	 ship: (GGShip *)_ship;
@end

@interface StupidIA : GGTask
{
}
+ stupidIA: (GGShip *)_ship;
@end

extern NSString *GGNotificationArriveToStation;
  

#endif
