/* 	-*-ObjC-*- */
/*
 *  Texture.h
 *
 *  Copyright (c) 2001 by Frdric De Jaeger
 *  
 *  Date: Mars 2001
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __Texture_h
#define __Texture_h

#include <Foundation/NSObject.h>

#include "type.h"

@protocol TexInitializer
- (int) nCol;
- (void) colorBoxForPoint: (double [3]) pts
		       in: (unsigned char *) dest;
@end


@interface Texture : NSObject
{
  GLuint		idTexture;
}
+ stupidTexture;
+ textureWithFileName: (NSString *)fileName
	       mipmap: (BOOL) mipmap;
+ textureWithFileName: (NSString *)fileName;
- initWithTextureFile:(NSString *)fileName
	       mipmap: (BOOL) mipmap;
- (int) idTexture;
- initStartField: (void *)data 
	   width: (int) w 
	  height: (int) h;
- initForFont: (void *) data
	width: (int) w
       height: (int) h;
- initWithData: (void *)dataChar
	 width: (int) width
	height: (int) height
      channels: (int) ncomp
	mipmap: (BOOL) mipmap;
- (void) setSubImage: (void *)data
	      format: (GLint) format
	     xoffset: (int) xoffset
	     yoffset: (int) yoffset
	       width: (int) width
	      height: (int) height;

- (void) changeStarField: (void *)data 
		   width: (int) w 
		  height: (int) h;

- initBoxTexture: obj
	    size: (int) size	
	  mipmap: (BOOL) mipmap;
+ boxTexture: obj;
+ cubeMapTextureWithFileName: (NSString *)fileName;

@end


#endif
