/* 	-*-ObjC-*- */
/*
 *  TopView.h
 *
 *  Copyright (c) 2001 by Frdric De Jaeger
 *  
 *  Date: May 2001
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __TopView_h
#define __TopView_h

#include "NSView.h"
#include "GGSky.h"

#define MAXLOCALSTAR 1000
@class GGFont;
@class GGString;
@class Texture;

typedef enum __GUIState
{
  GUI_OtherView,
  GUI_SpaceView,
  GUI_CloseSystemsView,
  GUI_ShipView,
  GUI_CurrentSystemView,
  GUI_StationView
}GUIState;


@interface TopView : NSView
{
  GGString 	*title;
  Texture 	*t;
  GUIState	_state;
}

- (void) open;
- (void) close;
+ topview;
- (void) setTexture: (Texture *)_t;
- (void) enableTextureBackground;
- (GGString *) titleView;
- (GUIState) state;
- (void) setState: (GUIState) newState;
@end

extern NSString *GGTopViewClosing;

#endif
