%{
  //#define YYSTYPE id
#include "parser.h"
id resultParsing;
%}

%union {
double   	valDouble;
int	 	valInteger;
id		node;
}

%token <valDouble> DOUBLE
%token <valInteger> INTEGER
%token <str> IDENT
%token <str> STRING
%token FALSE
%token TRUE
%token SHAPE
%token EOFTOKEN
%token COLOR
%token COORD
%token COORDINDEX
%token POINT


%type <node> data
%type <node> shapeinput
%type <node> vecteur
%type <node> vecteurCouleur
%type <node> sequence     
%type <node> sequenceCouleur
%type <node> coordonnees
%type <node> facelist
%type <node> couleurs
%type <node> shapeinput
%type <node> shapeproperty
%type <node> geometry
%type <node> info


%%
input:  data junk { resultParsing = $1; }
;

data:   SHAPE '{' geometry info '}' { $$ = $3; }
;

geometry: GEOMETRY STRING '{' shapeinput '}' { $$ = $4;}
;

info: /* rien */ { $$ = (void *)0; }
| STRING DOUBLE info { $$ = addInfo($3,$1, $2);}

junk: EOFTOKEN
| IDENT '{' corejunk  junk {}
;

corejunk: '}'
| IDENT argident corejunk {}
;

argident: DOUBLE {}
| INTEGER {}
| STRING {}
| vecteur {}
| vecteurCouleur {}
| vecteur3d {}
;


vecteur: '[' sequence ']' {$$ = $2; }
;

vecteur3d: DOUBLE DOUBLE DOUBLE {}
;

sequence: DOUBLE { $$ = mkVectFromDouble($1); }
| sequence ',' DOUBLE { $$ = addDoubleToVect($1, $3); }

vecteurCouleur: '[' sequenceCouleur ']' {$$ = $2 ;}
;

sequenceCouleur: DOUBLE ',' DOUBLE ',' DOUBLE { $$=mkVectCouleur($1, $3, $5); }
| sequenceCouleur  DOUBLE ',' DOUBLE ',' DOUBLE 
    {$$ = addCouleurToVect($1, $2, $4, $6); }
;

shapeinput: shapeproperty {$$ = shapeWithProperty($1);}
| shapeinput shapeproperty {$$ = addShapeProperty($1, $2); }
;

shapeproperty: couleurs { $$ = $1; }
| facelist { $$ = $1; }
| coordonnees { $$ = $1; } 
;

couleurs: COLOR STRING '{' COLOR  vecteurCouleur '}' { $$ = mkCouleurs($5); }
;

facelist: COORDINDEX vecteur { $$=mkFaceList($2); }
;

coordonnees: COORD STRING '{' POINT vecteur '}' { $$=mkVertices($5);}
;

     
%%
