/*
 *  type.h
 *
 *  Copyright (c) 2001 by Frdric De Jaeger
 *  
 *  Date: April 2001
 *
 *
 *  This program is free software; you can redistribute it and/or modify
 *  it under the terms of the GNU General Public License as published by
 *  the Free Software Foundation; either version 2 of the License, or
 *  (at your option) any later version.
 *
 *  This program is distributed in the hope that it will be useful,
 *  but WITHOUT ANY WARRANTY; without even the implied warranty of
 *  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 *  GNU General Public License for more details.
 *
 *  You should have received a copy of the GNU General Public License
 *  along with this program; if not, write to the Free Software
 *  Foundation, Inc., 675 Mass Ave, Cambridge, MA 02139, USA.
 */

#ifndef __type_h
#define __type_h

#include "config.h"

/*hack if using with C++*/
#ifdef __cplusplus
typedef bool BOOL;
#define YES 1
#define NO 0
#else
#ifndef __OBJC__
typedef unsigned char BOOL;
#define YES 1
#define NO 0
#endif
#endif


typedef struct __vect3D
{
  real x, y, z;
}Vect3D;

typedef struct __vect4D
{
  Vect3D 	v;
  real		w;
}Vect4D;

typedef Vect4D Plan;

typedef struct __Couleur4D
{
  GLfloat r, g, b, a;
}VectCol;

typedef struct __deplacement
{
  Vect3D	gauche;
  real		nul2;
  Vect3D	haut;
  real		nul3;
  Vect3D	direction;
  real	 	nul1;
  Vect3D	position;
  real		unite;
}GGMatrix4;

typedef struct __GGGalileen
{
  GGMatrix4 	matrice;	//position
  Vect3D	speed;	//try to guess !
}GGGalileen;

typedef struct __PetitGalileen
{
  Vect3D	point, speed;
}PetitGalileen;

typedef struct __projection_param
{
  GLfloat 		xFoc, yFoc, ratio, zmin, zmax;
  int			x, y, width, height;
  BOOL			label;
}ProjectionParam;

#ifdef DEBUG
@class GGSpaceObject;
#endif

typedef struct __camera
{
  ProjectionParam	*param;
  GGMatrix4		modelView;
  struct __camera	*prev;
#ifdef DEBUG
  GGSpaceObject		*owner;
#endif
}Camera;


typedef struct __interLeavedT2V3
{
  GLfloat s, t, x, y, z;
}InterLeavedT2V3;


typedef   struct __box
{
  short	top, bottom;
}box;

typedef struct __frustum
{
  Plan	devant, droite, gauche, haut, bas;
  unsigned	idev, idro, igau, ihau, ibas;
}Frustum;

#endif
