/* 	-*-ObjC-*- */
#ifndef __Utile_h
#define __Utile_h

#include <math.h>
#include "GG3D.h"

double gettimesec(void);
double vrnd(void);
unsigned irnd(unsigned max); /* get an integer a such that 0 <= a <= max-1*/

static inline double square(double val)
{
  return val*val;
}

static inline float GGClamp(float x)
{
  if( x > 1 )
    return 1;
  if (x < -1 )
    return -1;
  return x;
}


#ifndef M_PI
#define M_PI 3.1415926535
#endif

double ggmod(double x, double y);

static inline double to2pi(double x)
{
  return ggmod(x, 2*M_PI);
}

void writeRGBTofileJPG(int width, int height, const unsigned char *data);
void writeRGBTofile(int width, int height, const unsigned char *data);

struct __star;
float absoluteMagnitude(struct __star *s);
real omegaOrbite(real radius, real orbiteRadius);
void normaliseMatrice(GGMatrix4 *mat);

#ifdef DebugMem
void *__ggalloc(int size, char *chaine);
void checkMem(void);
#define ggalloc(size) __ggalloc((size), __FUNCTION__)
#else
void *ggalloc(int size);
#define checkMem()
#endif

void ggretain(void *ptr);
void ggrelease(void *ptr);
void ggSetDestructor(void *ptr, void (*f)(void *));
#define ggdestroy(ptr) \
do{\
void *p;\
p = (ptr);\
ggrelease(p);\
(ptr) = NULL;}while(0)


typedef struct __mapcol
{
  float 	val;
  VectCol	couleur;
}MapCol;

VectCol genColFromMapHeight(MapCol map[], int size, float param);


static MapCol __mapCol[] = 
{
  { 0, {  0, 0, 0.5, 1}},
  { 1, {  0, 0.6, 0, 1}},
  { 300, {  0.5, 0.5, 0.2, 1}},
  { 600, {  0.8, 0.5, 0.5, 1}},
  { 800, { 0.7, 0.7, 0.7, 1}}};

static inline VectCol genColFromHeight(float hight)
{
  return genColFromMapHeight(__mapCol, sizeof(__mapCol)/sizeof(MapCol), hight);
}

unsigned char *rawImageFromJPGFileMalloc(const char *fileName, int *pwidth,
					 int *pheight, int *pncomp);


#ifdef __OBJC__

@class GGSpaceObject;
@class GGGlyphLayout;
#include <Foundation/NSGeometry.h>


real distanceAbsolu2(GGSpaceObject *o1, GGSpaceObject *o2);
NSString *stringOfVect2(Vect3D v);
NSString *stringOfVect(Vect3D *v);
NSString *stringOfMatrice(GGMatrix4 *aMat);
void logArray(NSArray *array);

void drawRectBorder(short int x1, short int y1, short int x2, short int y2);

void printstring(void *font, const char *string);
void GGPrintString(void *font, NSString *str);
void pushStandardRep(NSSize size);
void popStandardRep();

static inline real distanceAbsolu(GGSpaceObject *o1, GGSpaceObject *o2)
{
  return sqrt(distanceAbsolu2(o1, o2));
}

BOOL getWinCoordinates(const Camera *c, const Vect3D *vec, Vect3D *res);
void draw3DstringFast(Camera *c, real x, real y, real z, GGGlyphLayout *str);

void printGLError(id);
#else
#ifdef DEBUG
#define GGCondition(condition)			\
    do{\
    if( !(condition) ){\
       fprintf(stderr, "Condition %s failed in file %s line %d\n", #condition, \
       __FILE__, __LINE__); abort();}}while(0)

#define GGWarn(condition)			\
    do{\
    if( (condition) )\
       fprintf(stderr, "Condition %s failed in file %s line %d\n", #condition, \
       __FILE__, __LINE__); }while(0)
#else
#define GGCondition(condition)
#define GGWarn(condition)
#endif

#endif

#endif
